#!/usr/bin/env python

import serial

F_CPU	= 18432000

LP_INT0	= 0xc0
LP_PCINT= 0xc1
LP_END	= 0xcf

mask = 0xff

signals = "!@#$%&'()" # add more if needed
header = """$date
16-Sep-2003 13:37:00
$end

$version
Domen's logic probe v 0.1
$end

$timescale
1 us
$end

$scope module krneki $end"""

print header
n_signals = 8
for i in range(n_signals):
	print "$var wire 1 %c SIG%i $end" % (signals[i], i)
print "$var wire 1 %c overflow $end" % signals[8]
print """$upscope $end

$enddefinitions $end

#0

$dumpvars"""
for i in range(n_signals):
	print " 0%c" % signals[i]
print " 0%c" % signals[8]
print "$end"

ser = serial.Serial(0, 115200);

test_string = "Self test is OK if this string is OK!\n"
ser.write(test_string)
if ser.readline() != test_string:
	print "XXX self test failed"
	aoeu

ser.write("%c" % LP_PCINT)
ser.write("%c" % mask)

try:
	lastx = 0
	lasttime = 0
	lastpins = 0x00
	while 1:
		x = ord(ser.read(1))
		x |= ord(ser.read(1)) << 8
		x |= ord(ser.read(1)) << 16
		pins = ord(ser.read(1))

		if x == 0xffffff:
			print "#%i" % (lasttime + 1)
			print " 1%c" % signals[8]
			print "#%i" % (lasttime + 2)
			print " 0%c" % signals[8]
			continue

		diff = x - lastx
		if diff < 0:
			diff += 2**24

		time = 1000000.0 / F_CPU * diff
		lastx = x

#		print "%i: %6i us" % (level, time)
		if lasttime != 0:
			lasttime += time
		else:
			lasttime = 100

		print "#%i" % lasttime
		for i in range(n_signals):
			if (pins ^ lastpins) & (1<<i):
				print " %i%c" % ((pins & (1<<i)) != 0, signals[i])
		lastpins = pins
except:
	ser.write("%c" % LP_END);
